#include "pandorainput.h"

#include <tslib.h>

#include <linux/input.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

void getMousePress(struct MousePress * mousePress)
{
	mousePress->pressed_  = 0;
	mousePress->x_  = 0;
	mousePress->y_  = 0;

	static struct tsdev * touchscreen = 0;
	if (!touchscreen)
	{
		int i=0;
		char name[256];
		char touchscreendev[256];
		int fd=-1;
		for(;;++i)
		{
			sprintf(name, "/dev/input/event%i", i);
			fd = open(name, O_RDONLY|O_NONBLOCK);
			if (fd < 0) break; /* no more devices */
				ioctl(fd, EVIOCGNAME(sizeof(name)), name);
			if (strcmp(name, "touchscreen") == 0)
			{
				sprintf(touchscreendev,"/dev/input/event%d",i);
				close(fd);
				continue;
			}
			close(fd); /* we don't need this device */
		}

		touchscreen = ts_open(touchscreendev,1);
		ts_config(touchscreen);
		//ts_close(d_touchscreen);
	}

	struct ts_sample touchsample;
	int touchres = ts_read(touchscreen, &touchsample, 1);
	if(touchres!=0 && touchsample.pressure!=0)
	{
		mousePress->pressed_  = 1;
		mousePress->x_ = touchsample.x;
		mousePress->y_ = touchsample.y;
	}
}

void queryLeftNub(struct NubPosition * nubPosition)
{
	nubPosition->x_ = 0;
	nubPosition->y_ = 0;

	static int fd=-1;
	if (fd==-1)
	{
		int i=0;
		char name[256];
		for(;;++i)
		{
			sprintf(name, "/dev/input/event%i", i);
			fd = open(name, O_RDONLY|O_NONBLOCK);
			if (fd < 0) break; /* no more devices */
				ioctl(fd, EVIOCGNAME(sizeof(name)), name);
			if (strcmp(name, "nub0") == 0)
				break;
			close(fd); /* we don't need this device */
		}
	}

	struct input_absinfo xinfo;	
	struct input_absinfo yinfo;
	memset(&xinfo,0,sizeof(xinfo));
	ioctl(fd, EVIOCGABS(ABS_X), &xinfo);
	memset(&yinfo,0,sizeof(yinfo));
	ioctl(fd, EVIOCGABS(ABS_Y), &yinfo);

	nubPosition->x_ = xinfo.value;
	nubPosition->y_ = yinfo.value;
}

void queryRightNub(struct NubPosition * nubPosition)
{
	nubPosition->x_ = 0;
	nubPosition->y_ = 0;

	static int fd=-1;
	if (fd==-1)
	{
		int i=0;
		char name[256];
		for(;;++i)
		{
			sprintf(name, "/dev/input/event%i", i);
			fd = open(name, O_RDONLY|O_NONBLOCK);
			if (fd < 0) break; /* no more devices */
				ioctl(fd, EVIOCGNAME(sizeof(name)), name);
			if (strcmp(name, "nub1") == 0)
				break;
			close(fd); /* we don't need this device */
		}
	}

	struct input_absinfo xinfo;	
	struct input_absinfo yinfo;
	memset(&xinfo,0,sizeof(xinfo));
	ioctl(fd, EVIOCGABS(ABS_X), &xinfo);
	memset(&yinfo,0,sizeof(yinfo));
	ioctl(fd, EVIOCGABS(ABS_Y), &yinfo);

	nubPosition->x_ = xinfo.value;
	nubPosition->y_ = yinfo.value;
}

