#include <gpdef.h>
#include <gpstdlib.h>
#include <gpfont.h>
#include <initval_port.h>

#include "gpfont_port.h"
#include "gpfontres.dat"
#include "gpmain.h"

#define USE_GP_MEM 1

#ifdef USE_GP_MEM
#include "gpmem.h"
#endif

unsigned int HEAPSTART;
unsigned int HEAPEND;

int clockSpeed;

void InitializeFont(void);
extern void GpKeyPollingTimeSet(int loop_cnt);
void Main(int arg_len, char * arg_v)
{
	
	GM_HEAP_DEF gm_heap_def;
	
/*#if CHANGE_MCLK	
	GpClockSpeedChange(CLK_SPEED, DIV_FACTOR, CLK_MODE);
#endif*/
	int div, magic;
//	GpClockSpeedChange (40000000, 0x48013, 1);
//	GpClockSpeedChange (59250000, 0x47022, 1);
//	GpClockSpeedChange (67500000, 0x25002, 1);
//	GpClockSpeedChange (80000000, 0x48012, 1);
//	GpClockSpeedChange (99000000, 0x3a002, 2);
	clockSpeed = 99000000;  div =2; magic = 0x3a002;
	clockSpeed = 116000000; div =2; magic = 0x32011;
	clockSpeed = 132000000; div =2; magic = 0x24001;
//	clockSpeed = 156000000; div =3; magic = 0x2c001;
	clockSpeed = 165000000; div =3; magic = 0x2f001;
	GpClockSpeedChange(clockSpeed, magic, div);
	if (div>1)
		div = 2<<(div-2);
	clockSpeed /= div;
//	clockSpeed = 40000000;
//	GpClockSpeedChange(clockSpeed, 0x48013, 0);
	
	_gp_sdk_init();
	
	//keyboard polling count setting
	GpKeyPollingTimeSet(KEYPOLLING_NUM);
	
#ifdef USE_GP_MEM
	gm_heap_def.heapstart = (void*)(HEAPSTART);
	gm_heap_def.heapend = (void *)(HEAPEND & ~3); //<== BOOTROM SPECTIFIC
	gm_heap_init(&gm_heap_def);
	
	gp_mem_func.malloc = gm_malloc;
	gp_mem_func.zimalloc = gm_zi_malloc;
	gp_mem_func.calloc = gm_calloc;
	gp_mem_func.free = gm_free;
	gp_mem_func.availablemem = gm_availablesize;
	gp_mem_func.malloc_ex = gm_malloc_ex;
	gp_mem_func.free_ex = gm_free_ex;
	gp_mem_func.make_mem_partition = gm_make_mem_part;
	
	gp_str_func.memset = gm_memset;
	gp_str_func.memcpy = gm_memcpy;
	gp_str_func.strcpy = gm_strcpy;
	gp_str_func.strncpy = gm_strncpy;
	gp_str_func.strcat = gm_strcat;
	gp_str_func.strncat = gm_strncat;
#if 1
	gp_str_func.gpstrlen = gm_lstrlen;
#else
	gp_str_func.lstrlen = gm_lstrlen;
#endif
	gp_str_func.sprintf = gm_sprintf;
	gp_str_func.uppercase = gm_uppercase;
	gp_str_func.lowercase = gm_lowercase;
	gp_str_func.compare = gm_compare;
	gp_str_func.trim_right = gm_trim_right;
#endif /*USE_GP_MEM*/
	
	//Font initialize
	InitializeFont();

	GpKernelInitialize();
	GpKernelStart();
	GpAppExit();
	while(1);
}

void InitializeFont(void)
{
	BGFONTINFO mInfo;
	mInfo.kor_w = KORFONT_W;
	mInfo.kor_h = KORFONT_H;
	mInfo.eng_w = ENGFONT_W;
	mInfo.eng_h = ENGFONT_H;
	mInfo.chargap = FONT_CHARGAP;
	mInfo.linegap = FONT_LINEGAP;
	GpFontInit(&mInfo);
	GpFontResSet((unsigned char*)fontresKor, (unsigned char*)fontresEng);	
}

int GpPredefinedStackGet(H_THREAD th)
{
	switch ( th )
	{
	case H_THREAD_GPMAIN:
		return GPMAIN_STACK_SIZE;
	case H_THREAD_NET:
		return NET_STACK_SIZE;
	case H_THREAD_TMR0:
	case H_THREAD_TMR1:
	case H_THREAD_TMR2:
	case H_THREAD_TMR3:
		return USER_STACK_SIZE;
	default:
		return 0;
	}
}
