#include <stdio.h>
#include "jpeglib.h"

int main(void)
{
	struct jpeg_decompress_struct cinfo;
	struct jpeg_error_mgr jerr;
	FILE * infile;
	JSAMPARRAY buffer, buffer2;
	int row_stride;
	infile = fopen("test.jpg", "r");
	if (infile)
	{
		cinfo.err = jpeg_std_error(&jerr);
		jpeg_create_decompress(&cinfo);
		jpeg_stdio_src(&cinfo, infile);
		jpeg_read_header(&cinfo, TRUE);
		jpeg_start_decompress(&cinfo);

		char * temp = malloc(320*240*2);

		row_stride = cinfo.output_width * cinfo.output_components;
		buffer = (*cinfo.mem->alloc_sarray)((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
		buffer2 = (*cinfo.mem->alloc_sarray)((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);

		unsigned int * mem = temp;
		mem+=120;
		while (cinfo.output_scanline < cinfo.output_height) {
			jpeg_read_scanlines(&cinfo, buffer, 1);	
			jpeg_read_scanlines(&cinfo, buffer2, 1);	

			int i=0;
			unsigned char * src = buffer[0];
			unsigned char * src2 = buffer2[0];
			unsigned char r,r2,g,g2,b,b2;
			for (i=0; i<960; i+=3)
			{
				r = (src[i]&0xf8);
				r2 = (src2[i]&0xf8);
				g = (src[i+1]&0xf8);
				g2 = (src2[i+1]&0xf8);
				b = (src[i+2]&0xf8);
				b2 = (src[i+2]&0xf8);

				unsigned int col = (unsigned int)r2<<8 | (unsigned int)g2<<3 | (unsigned int)b2>>2 | (unsigned int)r<<24 | (unsigned int)g<<19 | (unsigned int)b<<14;

				*mem = col;
				mem+=120;
			}
			mem-=(120*320)+1;
		}

		jpeg_finish_decompress(&cinfo);
		fclose(infile);

		FILE * output = fopen("output.gp32", "w");
		fwrite(temp, 320*240*2, 1, output);
		fclose(output);
		
		free(temp);
	}
}

