#include "gp2xjoy.h"
#include "gp2xgp32compat.h"

#include <fcntl.h>
#include <unistd.h>
//#include <SDL/SDL.h>
#include <sys/soundcard.h>

#define GP2XJOY_U 1
#define GP2XJOY_UL 2
#define GP2XJOY_L 4
#define GP2XJOY_DL 8
#define GP2XJOY_D 16
#define GP2XJOY_DR 32
#define GP2XJOY_R 64
#define GP2XJOY_UR 128

//static int fd = -1;
static int strategy = 1;

static unsigned int buf;

void readAllJoy(int * switches, int * x, int * y, int * buttons)
{
#ifdef NATY
	*x = 0;
	*y = 0;
	*buttons = 0;
	int count;
	SDL_PumpEvents();
	Uint8 * state = SDL_GetKeyState(&count);
	*switches = 0;
	if (state[SDLK_UP] || state[SDLK_i] )
		{*y=-1;*switches=1;}
	else if (state[SDLK_DOWN] || state[SDLK_k])
		{*y=1;*switches=16;}
	else if (state[SDLK_LEFT] || state[SDLK_j])
		{*x=-1;*switches=4;}
	else if (state[SDLK_RIGHT] || state[SDLK_l])
		{*x=1;*switches=64;}
	
	if (state[SDLK_a])
		*buttons |= GPC_VK_FA;
	if (state[SDLK_b])
		*buttons |= GPC_VK_FB;
	if (state[SDLK_r])
		*buttons |= GPC_VK_FR;
	if (state[SDLK_y])
		*buttons |= GPC_VK_FY;
	if (state[SDLK_x])
		*buttons |= GPC_VK_FX;
	if (state[SDLK_l])
		*buttons |= GPC_VK_FL;
	if (state[SDLK_s])
		*buttons |= GPC_VK_START;
	if (state[SDLK_e])
		*buttons |= GPC_VK_SELECT;

	//printf("x:%d y:%d\n",*x,*y);
	return;
#endif	
	
	//if (fd == -1)
	//	fd = open ("/dev/GPIO", O_RDONLY);

	//read (fd, buf, 4);
	buf = gp2x_joystick_read();

	int xoff = 0;
	int yoff = 0;
	int joy = buf&0xff;
	//tweaks for dpad
	if ((joy&(GP2XJOY_U|GP2XJOY_R)) == (GP2XJOY_U|GP2XJOY_R) )
		joy = GP2XJOY_UR;
	else if ((joy&(GP2XJOY_U|GP2XJOY_L)) == (GP2XJOY_U|GP2XJOY_L))
		joy = GP2XJOY_UL;
	else if ((joy&(GP2XJOY_D|GP2XJOY_R)) == (GP2XJOY_D|GP2XJOY_R))
		joy = GP2XJOY_DR;
	else if ((joy&(GP2XJOY_D|GP2XJOY_L)) == (GP2XJOY_D|GP2XJOY_L))
		joy = GP2XJOY_DL;
	*switches = joy;
	
	// Now usual handling - note that U/R/D/L are done first only - means only angles alone are done...
	if (joy&GP2XJOY_U)
		{yoff = -1;}
	else if (joy&GP2XJOY_R)
		{xoff = +1;}
	else if (joy&GP2XJOY_D)
		{yoff = +1;}
	else if (joy&GP2XJOY_L)
		{xoff = -1;}
	else if (joy&GP2XJOY_UR)
		{xoff = +1; yoff = -1;}
	else if (joy&GP2XJOY_DR)
		{xoff = +1; yoff = +1;}
	else if (joy&GP2XJOY_DL)
		{xoff = -1; yoff = +1;}
	else if (joy&GP2XJOY_UL)
		{xoff = -1; yoff = -1;}

	*x = xoff;
	*y = yoff;
	*buttons = (buf&0x0800ff00)>>8;
}

void readJoy(int * x, int * y)
{
	int dummy;
	readAllJoy(&dummy, x, y, &dummy);
}

int getButtons()
{
	int dummy, dx,dy,out;
	readAllJoy(&dummy,&dx,&dy,&out);
	return out;
}

int getX()
{
	int dummy,dx,dy,out;
	readAllJoy(&dummy,&dx,&dy,&out);
	return dx;
}

int getY()
{
	int dummy,dx,dy,out;
	readAllJoy(&dummy,&dx,&dy,&out);
	return dy;
}

int joyPressed()
{
	int dummy,x,y,out;
	readAllJoy(&dummy,&x,&y,&out);
	return (out|(x!=0)|(y!=0));
}




